package com.ti.mobpo

import androidx.lifecycle.viewmodel.initializer
import androidx.lifecycle.viewmodel.viewModelFactory
import com.ti.mobpo.data.AppContainer
import com.ti.mobpo.ui.util.FeatureManager
import com.ti.mobpo.ui.viewmodels.FavouritesViewModel
import com.ti.mobpo.ui.viewmodels.PokeSearchViewModel

object AppViewModelProvider {
    lateinit var appContainer: AppContainer
    lateinit var featureManager: FeatureManager

    fun initialize(appContainer: AppContainer, featureManager: FeatureManager) {
        this.appContainer = appContainer
        this.featureManager = featureManager
    }

    val Factory = viewModelFactory {
        initializer { ->
            PokeSearchViewModel(
                appContainer.favouritesRepository
            )
        }

        initializer { ->
            FavouritesViewModel(
                appContainer.favouritesRepository,
                featureManager
            )
        }
    }
}
