package com.ti.mobpo

import android.annotation.SuppressLint
import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import com.ti.mobpo.data.AppContainer
import com.ti.mobpo.data.AppDataContainer
import com.ti.mobpo.ui.Navigation
import com.ti.mobpo.ui.theme.MobileSecurityTheme
import com.ti.mobpo.ui.util.FeatureManager

class MainActivity : ComponentActivity() {

    lateinit var appContainer: AppContainer
        private set

    lateinit var featureManager: FeatureManager
        private set


    @SuppressLint("UnusedMaterial3ScaffoldPaddingParameter")
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContent {
            MobileSecurityTheme {
                Navigation(this@MainActivity)
            }
        }
        appContainer = createAppContainer()
        featureManager = createFeatrureManager()
        AppViewModelProvider.initialize(appContainer, featureManager)
    }

    private fun createAppContainer(): AppContainer {
        return AppDataContainer(this)
    }

    private fun createFeatrureManager(): FeatureManager {
        return FeatureManager(this)
    }
}
